# 企业微信（网页应用开发）


&lt;!--more--&gt;


## 实现远程验证回调企业微信本地接口服务开发场景

### 内网穿透
通过使用内网穿透工具提供的公网域名成功验证回调本地接口服务，企业微信开发者在应用的开发测试阶段，应用服务通常是部署在开发环境，在有数据回调的开发场景下，企业微信的回调数据无法直接请求到开发环境的服务。  

内网穿透工具可以帮助开发者将应用开发调试过程中的回调请求，穿透到本地的开发环境。`Cpolar` 是一种安全的内网穿透的服务，可以将内网下的本地服务器通过安全隧道暴露至公网，使得公网用户可以正常访问内网服务，是一款优秀内网穿透软件。  

`cpolar` 官网：{{&lt; link &#34;https://www.cpolar.com/&#34; &gt;}}  

安装完成后，启动软件，会在浏览器打开一个网页，输入邮箱、密码登录  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/1.jpg&#34; caption=&#34;(`图1`)&#34; &gt;}}  

隧道管理 -&gt; 创建隧道，创建一个本地服务的 `http` 隧道  
- 隧道名称：可自定义命名，注意不要与已有的隧道名称重复
- 协议：选择 `http`
- 本地地址：`8080` (回调自己本地服务的端口)
- 域名类型：免费选择随机域名
- 地区：选择 `China`

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/2.jpg&#34; caption=&#34;(`图2`)&#34; &gt;}}  

隧道创建成功后，状态 -&gt; 在线隧道列表，查看所生成的域名地址，有两种访问方式，分别是 `http` 和 `https`，域名我们需要记住，稍后在企业微信开发者中心创建应用的时候需要填写该域名!  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/3.jpg&#34; caption=&#34;(`图3`)&#34; &gt;}}  

进入微信企业开发者中心，登录后，点击上方工具，再点击左侧网页应用开发，进入创建应用界面，点击创建应用  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/4.jpg&#34; caption=&#34;(`图4`)&#34; &gt;}}  

把要求填写的域名信息，填写上面我们在 `cpolar` 中创建的域名，然后点击创建应用  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/5.jpg&#34; caption=&#34;(`图5`)&#34; &gt;}}  


### 创建项目引入加解密库
使用 `xml` 版本的  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/6.jpg&#34; caption=&#34;(`图6`)&#34; &gt;}}  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/7.jpg&#34; caption=&#34;(`图7`)&#34; &gt;}}  

解压后，放在 tool 文件夹中  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/8.jpg&#34; caption=&#34;(`图8`)&#34; &gt;}}  

``` xml {data-open=true,title=&#34;pom.xml&#34;}
&lt;!-- 针对org.apache.commons.codec.binary.Base64--&gt;
&lt;dependency&gt;
	&lt;groupId&gt;commons-codec&lt;/groupId&gt;
	&lt;artifactId&gt;commons-codec&lt;/artifactId&gt;
	&lt;version&gt;1.9&lt;/version&gt;
&lt;/dependency&gt;

&lt;!-- 使用IOUtils--&gt;
&lt;dependency&gt;
	&lt;groupId&gt;commons-io&lt;/groupId&gt;
	&lt;artifactId&gt;commons-io&lt;/artifactId&gt;
	&lt;version&gt;2.11.0&lt;/version&gt;
&lt;/dependency&gt;

&lt;!-- 企业微信json格式包--&gt;
&lt;dependency&gt;
	&lt;groupId&gt;org.json&lt;/groupId&gt;
	&lt;artifactId&gt;json&lt;/artifactId&gt;
	&lt;version&gt;20200518&lt;/version&gt;
&lt;/dependency&gt;

&lt;!-- dom4j解析xml --&gt;
&lt;dependency&gt;
	&lt;groupId&gt;org.dom4j&lt;/groupId&gt;
	&lt;artifactId&gt;dom4j&lt;/artifactId&gt;
	&lt;version&gt;2.1.1&lt;/version&gt;
&lt;/dependency&gt;
```


### 引入加密库后，提示非法字符&#39;\ufeff&#39;
该错误通常发生在尝试编译 `Java` 源代码文件时，文件开头的字符是一个字节顺序标记（`Byte Order Mark，BOM`），即 `\ufeff`。在 `Java` 中，`\ufeff` 不是一个合法的字符，因此编译器会报 &#34;非法字符: &#39;`\ufeff`&#39;&#34; 错误。  

解决方法  
- 在 `Idea` 界面右下角处将 `utf-8` 改为 `GBK`
- 在弹出的窗口中点击转换
- 接着再重新将编码格式改回 `utf-8` 就可以啦


### 验证可信域名
下载可信域名验证文件，并放到静态目录下  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/9.jpg&#34; caption=&#34;(`图9`)&#34; &gt;}}


### 验证回调
企业微信会先判断 `URL` 服务是否具备解析企业微信推送消息的能力，然后再发送业务回调，也就是连着发送两次请求，所以在 `command` 方法中，需要判断请求的类型，如果是 `get`，表示该请求用来验证是否具备解析能力，如果是 `post`，表示该请求用来执行业务回调  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/10.jpg&#34; caption=&#34;(`图10`)&#34; &gt;}}  

``` java {data-open=true,title=&#34;WeChatConfig.java&#34;}
@RestController
@RequestMapping(value = &#34;/callback&#34;)
public class WeChatConfig {

    /**
     * 3.1 支持Http Get请求验证URL有效性
     */
    @GetMapping(&#34;/data&#34;)
    public String data(HttpServletRequest request) throws IOException {
        String sEchoStr = &#34;&#34;;

        String sVerifyMsgSig = request.getParameter(&#34;msg_signature&#34;);
        String sVerifyTimeStamp = request.getParameter(&#34;timestamp&#34;);
        String sVerifyNonce = request.getParameter(&#34;nonce&#34;);
        String sVerifyEchoStr = request.getParameter(&#34;echostr&#34;);

        try {
            WXBizMsgCrypt wxcpt = new WXBizMsgCrypt(&#34;Nqyyj3yLDT4R2Q6idhtTJ2tP8t&#34;, &#34;F20sj9GfH8lx66HKirERy5zjoMCDGHdugTXVmOvXJ7f&#34;, &#34;&#34;);

            sEchoStr = wxcpt.VerifyURL(sVerifyMsgSig, sVerifyTimeStamp, sVerifyNonce, sVerifyEchoStr);
            System.out.println(&#34;verifyurl echostr: &#34; &#43; sEchoStr);
            // 验证URL成功，将sEchoStr返回
//            response.getWriter().write(sEchoStr);
            return sEchoStr;
        } catch (Exception e) {
            //验证URL失败，错误原因请查看异常
            e.printStackTrace();
//            response.getWriter().write(&#34;failed&#34;);
            return &#34;failed&#34;;
        }
    }

    /**
     * 3.2 支持Http Post请求接收业务数据
     *
     * @return
     */
    @RequestMapping(value = &#34;/command&#34;, method = {RequestMethod.GET, RequestMethod.POST})
    public String command(HttpServletRequest request, @RequestBody(required = false) String body) throws Exception {
        // 判断请求方法
        String method = request.getMethod();
        if (&#34;GET&#34;.equalsIgnoreCase(method)) {
            return data(request);
        } else {
            String sReqMsgSig = request.getParameter(&#34;msg_signature&#34;);
            String sReqTimeStamp = request.getParameter(&#34;timestamp&#34;);
            String sReqNonce = request.getParameter(&#34;nonce&#34;);

            try {
                //wwfb662f05212e49eb是应用id
                WXBizMsgCrypt wxcpt = new WXBizMsgCrypt(&#34;Nqyyj3yLDT4R2Q6idhtTJ2tP8t&#34;, &#34;F20sj9GfH8lx66HKirERy5zjoMCDGHdugTXVmOvXJ7f&#34;, &#34;wwfb662f05212e49eb&#34;);
                //解密
                String sMsg = wxcpt.DecryptMsg(sReqMsgSig, sReqTimeStamp, sReqNonce, body);
                System.out.println(&#34;解密后的数据:&#34; &#43; sMsg);
                //将post数据转换为map
                Map&lt;String, String&gt; dataMap = MessageUtil.parseXml(sMsg);
                System.out.println(&#34;转为map的数据：&#34; &#43; dataMap.toString());

                return &#34;success&#34;;
            } catch (AesException e) {
                throw new RuntimeException(e);
            }
        }
    }
}
```

``` java {data-open=true,title=&#34;MessageUtil.java&#34;}
package com.example.demo.tool;

import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MessageUtil {

    /**
     * 返回消息类型：文本.
     */
    public static final String RESP_MESSAGE_TYPE_TEXT = &#34;text&#34;;

    /**
     * 返回消息类型：音乐.
     */
    public static final String RESP_MESSAGE_TYPE_MUSIC = &#34;music&#34;;

    /**
     * 返回消息类型：图文.
     */
    public static final String RESP_MESSAGE_TYPE_NEWS = &#34;news&#34;;

    /**
     * 请求消息类型：文本.
     */
    public static final String REQ_MESSAGE_TYPE_TEXT = &#34;text&#34;;

    /**
     * 请求消息类型：图片.
     */
    public static final String REQ_MESSAGE_TYPE_IMAGE = &#34;image&#34;;

    /**
     * 请求消息类型：链接.
     */
    public static final String REQ_MESSAGE_TYPE_LINK = &#34;link&#34;;

    /**
     * 请求消息类型：地理位置.
     */
    public static final String REQ_MESSAGE_TYPE_LOCATION = &#34;location&#34;;

    /**
     * 请求消息类型：音频.
     */
    public static final String REQ_MESSAGE_TYPE_VOICE = &#34;voice&#34;;

    /**
     * 请求消息类型：推送.
     */
    public static final String REQ_MESSAGE_TYPE_EVENT = &#34;event&#34;;

    /**
     * 事件类型：subscribe(订阅).
     */
    public static final String EVENT_TYPE_SUBSCRIBE = &#34;subscribe&#34;;

    /**
     * 事件类型：unsubscribe(取消订阅).
     */
    public static final String EVENT_TYPE_UNSUBSCRIBE = &#34;unsubscribe&#34;;

    /**
     * 事件类型：CLICK(自定义菜单点击事件).
     */
    public static final String EVENT_TYPE_CLICK = &#34;CLICK&#34;;

    /**
     * 事件类型：taskcard_click(点击任务卡片按钮).
     */
    public static final String EVENT_TYPE_TASKCARD_CLICK = &#34;taskcard_click&#34;;

    /**
     * 事件类型：open_approval_change(审批状态通知事件).
     */
    public static final String EVENT_TYPE_OPEN_APPROVAL_CHANGE = &#34;open_approval_change&#34;;

    public static final String EVENT_TYPE_ENTER_AGENT = &#34;enter_agent&#34;;

    /**
     * 解析微信发来的请求（XML）.
     *
     * @param msg 消息
     * @return map
     */
    @SuppressWarnings(&#34;unchecked&#34;)
    public static Map&lt;String, String&gt; parseXml(final String msg) {
        // 将解析结果存储在HashMap中
        Map&lt;String, String&gt; map = new HashMap&lt;String, String&gt;();

        // 从request中取得输入流
        try (InputStream inputStream = new ByteArrayInputStream(msg.getBytes(StandardCharsets.UTF_8.name()))) {
            // 读取输入流
            SAXReader reader = new SAXReader();
            Document document = reader.read(inputStream);
            // 得到xml根元素
            Element root = document.getRootElement();
            // 得到根元素的所有子节点
            List&lt;Element&gt; elementList = root.elements();

            // 遍历所有子节点
            for (Element e : elementList) {
                map.put(e.getName(), e.getText());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return map;
    }
}
```

&gt; [!NOTE]
&gt; **数据回调 `URL` 申请校验不通过** \
&gt; 加解密库里，`ReceiveId` 在各个场景的含义不同：
&gt; - 企业应用的回调，表示 `corpid`
&gt; - 第三方事件的回调，表示 `suiteid`
&gt; - 个人主体的第三方应用的回调，`ReceiveId` 是一个空字符串
&gt; {{&lt; image src=&#34;/images/posts/企业微信网页应用开发/13.jpg&#34; caption=&#34;(`图13`)&#34; &gt;}}


### 应用安装测试，应用添加失败

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/11.jpg&#34; caption=&#34;(`图11`)&#34; &gt;}}  

``` java {data-open=true,title=&#34;WechatController.java&#34;}
@RestController
public class WechatController {

    @Autowired
    private WeChatConfig weChatConfig;

    /**
     * 安装测试应用，对微信的请求进行响应
     * @param request
     * @param body
     * @return
     * @throws Exception
     */
    @RequestMapping(value = &#34;/callback&#34;, method = {RequestMethod.GET, RequestMethod.POST})
    public String callback(HttpServletRequest request, @RequestBody(required = false) String body) throws Exception {
        return weChatConfig.command(request,body);
    }
}
```


### 企业微信网页应用的局限性
权限少，什么都干不了  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/12.jpg&#34; caption=&#34;(`图12`)&#34; width=&#34;669px&#34; height=&#34;350px&#34; &gt;}}  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/14.jpg&#34; caption=&#34;(`图14`)&#34; width=&#34;621px&#34; height=&#34;439px&#34; &gt;}}  

{{&lt; image src=&#34;/images/posts/企业微信网页应用开发/15.jpg&#34; caption=&#34;(`图15`)&#34; &gt;}}  




---
{.awesome-hr}

---

> 作者: [piliqiu](https://piliqiu.com/)  
> URL: https://piliqiu.com/posts/08ffe61/  

